#bygonebytes.co.uk (2021) High St onwands
import machine, utime
import _thread
from esp8266_i2c_lcd import I2cLcd
from machine import I2C

#display i2c
DEFAULT_I2C_ADDR = 0x27
sda=machine.Pin(0)
scl=machine.Pin(1)
i2c=machine.I2C(0,sda=sda, scl=scl, freq=400000)
lcd = I2cLcd(i2c, DEFAULT_I2C_ADDR, 4, 20)
address = 0x68
register = 0x00
bus = I2C(1)

# define outputs
swa = machine.Pin(2, machine.Pin.OUT)
swb = machine.Pin(3, machine.Pin.OUT)
swc = machine.Pin(4, machine.Pin.OUT)
swd = machine.Pin(5, machine.Pin.OUT)
swe = machine.Pin(6, machine.Pin.OUT)
swf = machine.Pin(7, machine.Pin.OUT)
swg = machine.Pin(8, machine.Pin.OUT)
swh = machine.Pin(9, machine.Pin.OUT)
exts = machine.Pin(10, machine.Pin.OUT)

#set outputs high
def reset():
    swa.value(1)
    swb.value(1)
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    
reset()
exts.value(1)

#define inputs
up = machine.Pin(11, machine.Pin.IN, machine.Pin.PULL_UP)
down = machine.Pin(12, machine.Pin.IN, machine.Pin.PULL_UP)
left = machine.Pin(13, machine.Pin.IN, machine.Pin.PULL_UP)
right = machine.Pin(14, machine.Pin.IN, machine.Pin.PULL_UP)
select = machine.Pin(15, machine.Pin.IN, machine.Pin.PULL_UP)
ack_in = machine.Pin(22, machine.Pin.IN, machine.Pin.PULL_UP)

# set default screen
def screen():
    lcd.move_to(0, 0)
    lcd.putstr(" TD Display Tester")
    lcd.move_to(0, 2)
    lcd.putstr("  To start press:   ")
    lcd.move_to(0, 3)
    lcd.putstr("  1, 2, 3, 4 or 5 ")

screen()

#define characters
def ampersand():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()    

def A():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()
    
def B():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def C():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def D():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def E():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def F():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def G():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def H():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()   

def I():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def J():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def K():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def L():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def M():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def N():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def O():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def P():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start() 

def Q():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def R():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def S():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def T():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def U():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def V():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def W():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def X():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def Y():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def Z():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def chr27():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def chr28():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def chr29():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)
    reset()
    start()

def chr30():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def blank():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(1)
    utime.sleep_ms(2)    
    reset()
    start()

def blank1():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr33():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def chr34():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr35():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr36():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr37():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def chr38():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr39():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr40():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()   

def chr41():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def asterisk():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr43():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr44():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def hyphen():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def chr46():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr47():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(1)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def zero():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start() 

def one():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def two():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def three():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def four():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def five():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def six():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def seven():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(1)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def eight():
    swc.value(1)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()    

def nine():
    swc.value(0)
    swd.value(1)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def chr58():
    swc.value(1)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def plus():
    swc.value(0)
    swd.value(0)
    swe.value(1)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def blank2():
    swc.value(1)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def chr61():
    swc.value(0)
    swd.value(1)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)
    reset()
    start()

def chr62():
    swc.value(1)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def question():
    swc.value(0)
    swd.value(0)
    swe.value(0)
    swf.value(0)
    swg.value(0)
    swh.value(0)
    utime.sleep_ms(2)    
    reset()
    start()

def ack():
    utime.sleep_ms(4)
    while True:
        if ack_in.value()==0:
            return
            utime.sleep_ms(1)
    
#start pulse
def start():
    exts.value(0)
    utime.sleep_ms(2)
    exts.value(1)
    ack()
#    utime.sleep_ms(5)

#common delays
def delay():
    utime.sleep_ms(750)
    
def delay2():
    utime.sleep_ms(1000)

#test sequences
def test1():
    lcd.move_to(0, 2)
    lcd.putstr(" Full Character Set ")
    lcd.move_to(0, 3)
    lcd.putstr("[                  ]")
    lcd.move_to(1, 3)    
    lcd.putstr("=")
    ampersand()
    delay2()
    A()
    delay2()
    B()
    delay2()
    C()
    lcd.putstr("=")
    delay2()
    D()
    delay2()
    E()
    delay2()
    F()
    delay2()
    G()
    lcd.putstr("=")
    delay2()
    H()
    delay2()
    I()
    delay2()
    J()
    delay2()
    K()
    lcd.putstr("=")
    delay2()
    L()
    delay2()
    M()
    delay2()
    N()
    delay2()
    O()
    lcd.putstr("=")
    delay2()
    P()
    delay2()
    Q()
    delay2()
    R()
    delay2()
    S()
    lcd.putstr("=")
    delay2()
    T()
    delay2()
    U()
    delay2()
    V()
    delay2()
    W()
    lcd.putstr("=")
    delay2()
    X()
    delay2()
    Y()
    delay2()
    Z()
    delay2()
    chr27()
    lcd.putstr("=")
    delay2()
    chr28()
    delay2()
    chr29()
    delay2()
    chr30()
    delay2()
    blank()
    lcd.putstr("=")
    delay2()
    blank1()
    delay2()
    chr33()
    delay2()
    chr34()
    delay2()
    chr35()
    lcd.putstr("=")
    delay2()
    chr36()
    delay2()
    chr37()
    delay2()
    chr38()
    delay2()
    chr39()
    lcd.putstr("=")
    delay2()
    chr40()
    delay2()
    chr41()
    delay2()
    asterisk()
    delay2()
    chr43()
    lcd.putstr("=")
    delay2()
    chr44()
    delay2()
    hyphen()
    delay2()
    chr46()
    delay2()
    chr47()
    delay2()
    zero()
    lcd.putstr("=")
    delay2()
    one()
    delay2()
    two()
    delay2()
    three()
    delay2()
    four()
    lcd.putstr("=")
    delay2()
    five()
    delay2()
    six()
    delay2()
    seven()
    delay2()
    eight()
    lcd.putstr("=")
    delay2()
    nine()
    delay2()
    chr58()
    delay2()    
    plus()
    delay2()
    blank2()
    lcd.putstr("=")
    delay2()
    chr61()
    delay2()
    chr62()
    delay2()
    question()
    delay2()
    blank()
    lcd.putstr("=")
    delay2()
    blank()
    delay2()
    blank()
    delay2()
    blank()
    lcd.putstr("=")
    delay2()
    screen()

def test2():
    lcd.move_to(0, 2)
    lcd.putstr("Berth & Descriptions")
    lcd.move_to(0, 3)
    lcd.putstr("   [             ]  ")
    lcd.move_to(4, 3)
    T()
    E()
    S()
    T()
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    N()
    D()
    A()
    blank()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    asterisk()
    asterisk()
    asterisk()
    asterisk()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    hyphen()
    N()
    B()
    hyphen()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    hyphen()
    N()
    D()
    hyphen()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    hyphen()
    C()
    O()
    hyphen()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay() 
    C()
    L()
    C()
    K()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    D()
    six()
    nine()
    seven()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    one()
    zero()
    zero()
    two()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    C()
    zero()
    three()
    nine()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    one()
    M()
    four()
    three()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    one()
    Z()
    zero()
    zero()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    two()
    P()
    six()
    three()
    lcd.putstr("=")
    delay2()
    blank()
    blank()
    blank()
    blank()
    delay()
    one()
    S()
    two()
    seven()
    delay2()   
    blank()
    blank()
    blank()
    blank()
    lcd.putstr("=")
    delay2()
    screen()    

def test3():
    lcd.move_to(0, 2)
    lcd.putstr("Alphanumeric Scroll ")
    lcd.move_to(0, 3)
    lcd.putstr("   [            ]   ")
    lcd.move_to(4, 3)
    lcd.putstr("=")
    ampersand()
    delay2()
    A()
    delay2()
    B()
    delay2()
    C()
    lcd.putstr("=")
    delay2()
    D()
    delay2()
    E()
    delay2()
    F()
    delay2()
    G()
    lcd.putstr("=")
    delay2()
    H()
    delay2()
    I()
    delay2()
    J()
    delay2()
    K()
    lcd.putstr("=")
    delay2()
    L()
    delay2()
    M()
    delay2()
    N()
    delay2()
    O()
    lcd.putstr("=")
    delay2()
    P()
    delay2()
    Q()
    delay2()
    R()
    delay2()
    S()
    lcd.putstr("=")
    delay2()
    T()
    delay2()
    U()
    delay2()
    V()
    delay2()
    W()
    lcd.putstr("=")
    delay2()
    X()
    delay2()
    Y()
    delay2()
    Z()
    delay2()
    zero()
    lcd.putstr("=")
    delay2()
    one()
    delay2()
    two()
    delay2()
    three()
    delay2()
    four()
    lcd.putstr("=")
    delay2()
    five()
    delay2()
    six()
    delay2()
    seven()
    delay2()
    eight()
    lcd.putstr("=")
    delay2()
    nine()
    delay2()
    hyphen()
    delay2()
    asterisk()
    delay2()
    question()
    lcd.putstr("=")
    delay2()
    chr47()
    delay2()
    blank()
    delay2()
    blank()
    delay2()
    blank()
    lcd.putstr("=")
    delay2()
    blank()
    delay2()
    screen()

def test4():
    lcd.move_to(0, 2)
    lcd.putstr("Static Description ")
    lcd.move_to(0, 3)
    lcd.putstr("    30 Seconds     ")
    chr47()
    chr47()
    chr47()
    chr47()
    delay()
    utime.sleep_ms(5000)
    lcd.move_to(4, 3)
    lcd.putstr("25")
    utime.sleep_ms(5000)
    lcd.move_to(4, 3)
    lcd.putstr("20")
    utime.sleep_ms(5000)
    lcd.move_to(4, 3)
    lcd.putstr("15")
    utime.sleep_ms(5000)
    lcd.move_to(4, 3)
    lcd.putstr("10")    
    utime.sleep_ms(5000)
    lcd.move_to(4, 3)
    lcd.putstr(" 5")
    utime.sleep_ms(4500)
    lcd.move_to(4, 3)
    lcd.putstr(" 0")    
    blank()
    blank()
    blank()
    blank()
    delay()    
    screen()
    
def test5():
    test1()
    test2()
    test3()

#wait for key presses
while True:
    if up.value()==0:
        test1()
    if left.value()==0:
        test2()
    if select.value()==0:
        test3()
    if right.value()==0:
        test4()
    if down.value()==0:
        test5()
